package de.itvsh.kop.common.binaryfile;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;

import com.fasterxml.jackson.core.JacksonException;
import com.fasterxml.jackson.core.JsonParser;
import com.fasterxml.jackson.databind.DeserializationContext;
import com.fasterxml.jackson.databind.deser.std.StdDeserializer;

import lombok.SneakyThrows;

public class FileDataDeserializer extends StdDeserializer<File> {

	protected FileDataDeserializer() {
		super(File.class);
	}

	@SneakyThrows
	@Override
	public File deserialize(JsonParser p, DeserializationContext ctxt) throws IOException, JacksonException {
		var tempFile = TempFileUtils.createTmpFile();

		try (var out = new FileOutputStream(tempFile.toFile())) {
			p.readBinaryValue(out);
			out.flush();
		}

		return tempFile.toFile();
	}

}
