/*
 * Copyright (C) 2022 Das Land Schleswig-Holstein vertreten durch den
 * Ministerpräsidenten des Landes Schleswig-Holstein
 * Staatskanzlei
 * Abteilung Digitalisierung und zentrales IT-Management der Landesregierung
 *
 * Lizenziert unter der EUPL, Version 1.2 oder - sobald
 * diese von der Europäischen Kommission genehmigt wurden -
 * Folgeversionen der EUPL ("Lizenz");
 * Sie dürfen dieses Werk ausschließlich gemäß
 * dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 *
 * https://joinup.ec.europa.eu/collection/eupl/eupl-text-eupl-12
 *
 * Sofern nicht durch anwendbare Rechtsvorschriften
 * gefordert oder in schriftlicher Form vereinbart, wird
 * die unter der Lizenz verbreitete Software "so wie sie
 * ist", OHNE JEGLICHE GEWÄHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrücklich oder stillschweigend - verbreitet.
 * Die sprachspezifischen Genehmigungen und Beschränkungen
 * unter der Lizenz sind dem Lizenztext zu entnehmen.
 */
package de.itvsh.kop.common.binaryfile;

import java.util.Objects;
import java.util.UUID;

import de.itvsh.kop.common.datatype.StringBasedValue;
import lombok.EqualsAndHashCode;

@EqualsAndHashCode(callSuper = true)
public class FileId extends StringBasedValue {

	private static final long serialVersionUID = 1L;

	FileId(String fileId) {
		super(fileId);
	}

	public static FileId createNew() {
		return from(UUID.randomUUID().toString());
	}

	public static FileId from(String fileId) {
		if (Objects.nonNull(fileId)) {
			return new FileId(fileId);
		}
		return null;
	}
}